--- native_fntests.log	2013-11-10 08:09:56 -0500
+++ /c/octave-2013-11-09-19-03/cross_fntests.log	2013-11-10 08:04:24 -0500
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\etc\tests\libinterp\corefcn\conv2.cc-tst
   ***** xtest
  assert (convn (a, b, "valid"), c(3:10,3:10,3:10));
 
@@ -67161,8 +67161,8 @@
        2.615625   2.847645   2.301085   1.887882   1.488562   1.453463   1.094118   0.904565
        1.639705   1.426894   0.880153   0.880482   0.360097   0.912007   0.537470   0.636259
 
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\etc\tests\libinterp\corefcn\data.cc-tst
   ***** test
  [v, i] = sort ([NaN, 1i, -1, Inf, 1, 1i]);
  assert (v, [1, 1i, 1i, -1, Inf, NaN]);
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\etc\tests\libinterp\corefcn\syscalls.cc-tst
+  ***** test
+ if (isunix ())
+   [in, out, pid] = popen2 ("sort", "-r");
+   EAGAIN = errno ("EAGAIN");
+ else
+   [in, out, pid] = popen2 ("sort", "/R");
+   EAGAIN = errno ("EINVAL");
+ endif
+ fputs (in, "these\nare\nsome\nstrings\n");
+ fclose (in);
+ done = false;
+ str = {};
+ idx = 0;
+ errs = 0;
+ do
+   if (!isunix ())
+     errno (0);
+   endif
+   s = fgets (out);
+   if (ischar (s))
+     idx++;
+     str{idx} = s;
+   elseif (errno () == EAGAIN)
+     fclear (out);
+     sleep (0.1);
+     if (++errs == 100)
+       done = true;
+     endif
+   else
+     done = true;
+   endif
+ until (done)
+ fclose (out);
+ if (isunix ())
+   assert (str, {"these\n","strings\n","some\n","are\n"});
+ else
+   assert (str, {"these\r\n","strings\r\n","some\r\n","are\r\n"});
+ endif
+!!!!! test failed
+ASSERT errors for:  assert (str,{"these\r\n", "strings\r\n", "some\r\n", "are\r\n"})
+
+  Location  |  Observed  |  Expected  |  Reason
+     .          O(0x0)       E(1x4)      Dimensions don't match
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\etc\tests\libinterp\dldfcn\fftw.cc-tst
   ***** testif HAVE_FFTW3_THREADS
  n = fftw ("threads");
  unwind_protect
@@ -67254,26 +67297,26 @@
  end_unwind_protect
 ----- skipped test
 
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\etc\tests\libinterp\octave-value\ov-class.cc-tst
   ***** testif HAVE_JAVA
  jobj = javaObject ("java.lang.StringBuffer");
  assert (class (jobj), "java.lang.StringBuffer");
 ----- skipped test
 
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\etc\tests\libinterp\octave-value\ov-java.cc-tst
   ***** testif HAVE_JAVA
  assert (javaObject ("java.lang.Short", 40000).doubleValue < 0);
 ----- skipped test
@@ -67283,139 +67326,139 @@
  assert (isfinite (str2double (jver{1})) && isfinite (str2double (jver{2})));
 ----- skipped test
 
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\etc\tests\libinterp\octave-value\ov-typeinfo.cc-tst
   ***** testif HAVE_JAVA
  x = javaObject ("java.lang.StringBuffer");
  assert (typeinfo (x), "octave_java");
 ----- skipped test
 
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\m\general\fieldnames.m
   ***** testif HAVE_JAVA 
  names = fieldnames ("java.lang.Double");
  search = strfind (names, "java.lang.Double.MAX_VALUE");
  assert (! isempty ([search{:}]));
 ----- skipped test
 
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\m\general\methods.m
   ***** testif HAVE_JAVA 
  mtds = methods ("java.lang.Double");
  search = strfind (mtds, "java.lang.Double valueOf");
  assert (! isempty ([search{:}]));
 ----- skipped test
 
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\m\general\num2str.m
   ***** xtest
  assert (num2str (1e23), "100000000000000000000000");
 !!!!! known failure
@@ -67423,220 +67466,220 @@
 
   Location  |  Observed  |  Expected  |  Reason
      []      99999999999999991611392      100000000000000000000000         Strings don't match
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\m\general\quadgk.m
   ***** assert (quadgk (@(z) log (z),1+1i,1+1i, "WayPoints", [1-1i, -1,-1i, -1+1i]), -pi * 1i, 1e-6)
 !!!!! test failed
 max_recursion_depth exceeded
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\m\java\usejava.m
   ***** testif HAVE_JAVA
  assert (usejava ("jvm"), true);
 ----- skipped test
 
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\m\plot\util\clf.m
   ***** xtest
  hf = figure ("visible", "off");
  unwind_protect
@@ -67658,52 +67701,63 @@
 
   Location  |  Observed  |  Expected  |  Reason
      []        tabloid      usletter     Strings don't match
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\m\plot\util\ndgrid.m
+  ***** test
+ x = 1:3;
+ assert (isequal (ndgrid (x), x(:)));
+!!!!! test failed
+reshape: can't reshape 1x3 array to 3x0 array
+  ***** assert (ndgrid ([]), zeros(0,1))
+!!!!! test failed
+ASSERT errors for:  assert (ndgrid ([]),zeros (0, 1))
+
+  Location  |  Observed  |  Expected  |  Reason
+     .          O(0x0)       E(0x1)      Dimensions don't match
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\m\polynomial\residue.m
   ***** xtest
  z1 =  7.0372976777e6;
  p1 = -3.1415926536e9;
@@ -67726,258 +67780,246 @@
 
   Location  |  Observed  |  Expected  |  Reason
      .          O(1x1)       E(1x2)      Dimensions don't match
->>>>> processing C:\MinGW\msys\1.0\home\jdonoghue\mxe-octave\usr\share\octave\3.7.7+\m\sparse\svds.m
-  ***** testif HAVE_ARPACK, HAVE_UMFPACK
- [u2,s2,v2,flag] = svds (A,k,0,opts);
- s2 = diag (s2);
- assert (flag, !1);
- tol = 10 * eps() * norm(s2, 1);
- assert (s2, s(k:-1:1), tol);
-
-!!!!! test failed
-ASSERT errors for:  assert (s2,s (k:-1:1),tol)
-
-  Location  |  Observed  |  Expected  |  Reason
-     .          O(6x1)       E(7x1)      Dimensions don't match
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\m\strings\dec2base.m
   ***** assert (dec2base (uint64 (2)^63-1, 16), "7FFFFFFFFFFFFFFF")
 !!!!! test failed
 ASSERT errors for:  assert (dec2base (uint64 (2) ^ 63 - 1, 16),"7FFFFFFFFFFFFFFF")
 
   Location  |  Observed  |  Expected  |  Reason
      []      8000000000000000   7FFFFFFFFFFFFFFF     Strings don't match
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\m\testfun\assert.m
   ***** error <Abs err 4.4409e-16 exceeds tol> assert (3+2*eps, 3, eps)
 !!!!! error failed.
 Expected <Abs err 4.4409e-16 exceeds tol> but got <ASSERT errors for:  assert (3 + 2 * eps,3,eps)
@@ -68006,12 +68048,12 @@
   Location  |  Observed  |  Expected  |  Reason
      ()          100          100        Abs err 2.8422e-014 exceeds tol 4.4409e-016>
 
+>>>>> processing C:\octave-2013-11-09-19-03\share\octave\3.7.7+\m\testfun\speed.m
   ***** xtest
  [order, n, T_f1, T_f2] = speed ("sum (x)", "", [100, 1000], "v = 0; for i = 1:length (x), v += x(i); endfor");
  assert (isstruct (order));
@@ -68026,21 +68068,21 @@
 !!!!! known failure
 speed: All running times were zero.