# HG changeset patch
# User Michael Godfrey <michaeldgodfrey@gmail.com>
# Date 1379637968 14400
#      Thu Sep 19 20:46:08 2013 -0400
# Node ID e7378124ed7890231f8254f184a248520cf2ffba
# Parent  ffa7f1caab4eb4cff7c96da43bdc12719141b545
sort TeX names to facilitate additions

diff -r ffa7f1caab4e -r e7378124ed78 libinterp/corefcn/oct-tex-symbols.in
--- a/libinterp/corefcn/oct-tex-symbols.in	Thu Sep 19 12:01:12 2013 -0700
+++ b/libinterp/corefcn/oct-tex-symbols.in	Thu Sep 19 20:46:08 2013 -0400
@@ -3,10 +3,12 @@
 # - symbol name
 # - Unicode code
 # - MS symbol code (http://www.kostis.net/charsets/symbol.htm)
+# - Arranged by listings in The TeXbook, Appendix F 
+# - Lowercase Greek letters: Greek Upper case: Misc Symbols type Ord: "Large" operators:
+# - Binary operators: Relations: Negated relations: Arrows: Openings: Closings: Alternate names:
+# - Other (not in Appendix F Tables):
 
 alpha           0x03B1  0xF061
-angle           0x2220  0xF0D0
-ast             0x2217  0xF02A
 beta            0x03B2  0xF062
 gamma           0x03B3  0xF067
 delta           0x03B4  0xF064
@@ -21,25 +23,13 @@
 mu              0x03BC  0xF06D
 nu              0x03BD  0xF06E
 xi              0x03BE  0xF078
+o               0x03BF  0xF0B0
 pi              0x03C0  0xF070
+varpi           0x03D6  0xF076
 rho             0x03C1  0xF072
 sigma           0x03C3  0xF073
 varsigma        0x03C2  0xF056
 tau             0x03C4  0xF074
-equiv           0x2261  0xF0BA
-Im              0x2111  0xF0C1
-otimes          0x2297  0xF0C4
-cap             0x2229  0xF0C7
-supset          0x2283  0xF0C9
-int             0x222B  0xF0F2
-rfloor          0x230B  0xF0FB
-lfloor          0x230A  0xF0EB
-perp            0x22A5  0xF05E
-wedge           0x2227  0xF0D9
-rceil           0x2309  0xF0F9
-vee             0x2228  0xF0DA
-langle          0x27E8  0xF0E1
-
 upsilon         0x03C5  0xF075
 phi             0x03C6  0xF066
 chi             0x03C7  0xF063
@@ -56,57 +46,68 @@
 Phi             0x03A6  0xF046
 Psi             0x03A8  0xF059
 Omega           0x03A9  0xF057
+aleph           0x2135  0xF0C0
+wp              0x2118  0xF0C3
+Re              0x211C  0xF0C2
+Im              0x2111  0xF0C1
+partial         0x2202  0xF0B6
+infty           0x221E  0xF0A5
+prime           0x2032  0xF0A2
+nabla           0x2207  0xF0D1
+surd            0x221A  0xF0D6
+angle           0x2220  0xF0D0
 forall          0x2200  0xF022
 exists          0x2203  0xF024
-ni              0x220B  0xF027
-cong            0x2245  0xF040
-approx          0x2248  0xF0BB
-Re              0x211C  0xF0C2
-oplus           0x2295  0xF0C5
-cup             0x222A  0xF0C8
-subseteq        0x2286  0xF0CD
-in              0x2208  0xF0CE
-lceil           0x2308  0xF0E9
-cdot            0x22C5  0xF0D7
 neg             0x00AC  0xF0D8
-times           0x00D7  0xF0B4
-surd            0x221A  0xF0D6
-varpi           0x03D6  0xF076
-rangle          0x27E9  0xF0F1
-
-sim             0x223C  0xF07E
-leq             0x2264  0xF0A3
-infty           0x221E  0xF0A5
 clubsuit        0x2663  0xF0A7
 diamondsuit     0x2666  0xF0A8
 heartsuit       0x2665  0xF0A9
 spadesuit       0x2660  0xF0AA
-leftrightarrow  0x2194  0xF0AB
+int             0x222B  0xF0F2
+pm              0x00B1  0xF0B1
+cdot            0x22C5  0xF0D7
+times           0x00D7  0xF0B4
+ast             0x2217  0xF02A
+circ            0x2218  0xF0B0
+bullet          0x2219  0xF0B7
+div             0x00F7  0xF0B8
+cap             0x2229  0xF0C7
+cup             0x222A  0xF0C8
+vee             0x2228  0xF0DA
+wedge           0x2227  0xF0D9
+oplus           0x2295  0xF0C5
+otimes          0x2297  0xF0C4
+oslash          0x2298  0xF0C6
+leq             0x2264  0xF0A3
+subset          0x2282  0xF0CC
+subseteq        0x2286  0xF0CD
+in              0x2208  0xF0CE
+geq             0x2265  0xF0B3
+supset          0x2283  0xF0C9
+supseteq        0x2287  0xF0CA
+ni              0x220B  0xF027
+mid             0x2223  0xF0BD
+equiv           0x2261  0xF0BA
+sim             0x223C  0xF07E
+approx          0x2248  0xF0BB
+cong            0x2245  0xF040
+propto          0x221D  0xF0B5
+perp            0x22A5  0xF05E
 leftarrow       0x2190  0xF0AC
 Leftarrow       0x21D0  0xF0DC
-uparrow         0x2191  0xF0AD
 rightarrow      0x2192  0xF0AE
 Rightarrow      0x21D2  0xF0DE
+leftrightarrow  0x2194  0xF0AB
+uparrow         0x2191  0xF0AD
 downarrow       0x2193  0xF0AF
-circ            0x2218  0xF0B0
-pm              0x00B1  0xF0B1
-geq             0x2265  0xF0B3
-propto          0x221D  0xF0B5
-partial         0x2202  0xF0B6
-bullet          0x2219  0xF0B7
-div             0x00F7  0xF0B8
+lfloor          0x230A  0xF0EB
+langle          0x27E8  0xF0E1
+lceil           0x2308  0xF0E9
+rfloor          0x230B  0xF0FB
+rangle          0x27E9  0xF0F1
+rceil           0x2309  0xF0F9
 neq             0x2260  0xF0B9
-aleph           0x2135  0xF0C0
-wp              0x2118  0xF0C3
-oslash          0x2298  0xF0C6
-supseteq        0x2287  0xF0CA
-subset          0x2282  0xF0CC
-o               0x03BF  0xF0B0
-nabla           0x2207  0xF0D1
 ldots           0x2026  0xF0BC
-prime           0x2032  0xF0A2
 0               0x2205  0xF0C6
-mid             0x2223  0xF0BD
 copyright       0x00A9  0xF0E3
-
 deg             0x00B0  0xF0B0